Index: /trunk/SophyaPI/PI/pigraphps.h
===================================================================
--- /trunk/SophyaPI/PI/pigraphps.h	(revision 4082)
+++ /trunk/SophyaPI/PI/pigraphps.h	(revision 4083)
@@ -38,6 +38,5 @@
   virtual void       DrawMarker(PIGrCoord x0, PIGrCoord y0);
   virtual void       DrawMarkers(PIGrCoord *x, PIGrCoord *y, int n);
-  virtual void       DrawPixmap(PIGrCoord x, PIGrCoord y, unsigned char *pix, 
-                                int sx, int sy, PIColorMap* cmap);
+  virtual void       DrawPixmap(PIGrCoord x, PIGrCoord y, PIPixColIdx & pix,  PIColorMap* cmap);
 
 // Modifications attributs graphiques
Index: /trunk/SophyaPI/PI/pigraphuc.cc
===================================================================
--- /trunk/SophyaPI/PI/pigraphuc.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/pigraphuc.cc	(revision 4083)
@@ -729,13 +729,12 @@
 
 /* --Methode-- */
-void PIGraphicUC::DrawPixmap(PIGrCoord x, PIGrCoord y, unsigned char *pix,
-                        int sx, int sy, PIColorMap* cmap)
-{
-  if (!mGrC) return;
-  if ( (sx < 1) || (sy < 1) )  return;
-  if ((pix == NULL) || (cmap == NULL)) return; 
+void PIGraphicUC::DrawPixmap(PIGrCoord x, PIGrCoord y, PIPixColIdx & pix, PIColorMap* cmap)
+{
+  if (!mGrC) return;
+  if ( (pix.XSize() < 1) || (pix.YSize() < 1) )  return;
+  if (cmap == NULL) return; 
   double xf,yf;
   UC2GrC(x, y, xf, yf);
-  mGrC->DrawPixmap(xf, yf, pix, sx, sy, cmap);
+  mGrC->DrawPixmap(xf, yf, pix, cmap);
 }
 
Index: /trunk/SophyaPI/PI/pigraphuc.h
===================================================================
--- /trunk/SophyaPI/PI/pigraphuc.h	(revision 4082)
+++ /trunk/SophyaPI/PI/pigraphuc.h	(revision 4083)
@@ -78,6 +78,5 @@
 				     bool fgline=true);
 
-  virtual void       DrawPixmap(PIGrCoord x, PIGrCoord y, unsigned char *pix, 
-                                int sx, int sy, PIColorMap* cmap);
+  virtual void       DrawPixmap(PIGrCoord x, PIGrCoord y, PIPixColIdx & pix, PIColorMap* cmap);
 
 // Modifications attributs graphiques
Index: /trunk/SophyaPI/PI/pigraphx.cc
===================================================================
--- /trunk/SophyaPI/PI/pigraphx.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/pigraphx.cc	(revision 4083)
@@ -384,6 +384,5 @@
 
 /* --Methode-- */
-void PIGraphicX::DrawPixmap(PIGrCoord x, PIGrCoord y, unsigned char *pix, 
-                            int sx, int sy, PIColorMap* cmap)
+void PIGraphicX::DrawPixmap(PIGrCoord x, PIGrCoord y, PIPixColIdx & pixc, PIColorMap* cmap) 
 {
 Window xw;
@@ -395,6 +394,7 @@
 XImage * ximg;
 
-if ( (sx < 1) || (sy < 1) )  return;
-if ((pix == NULL) || (cmap == NULL)) return; 
+int sx = pixc.XSize();
+int sy = pixc.YSize();
+if ((sx==0) || (sx==0) || (cmap == NULL)) return; 
 
   
@@ -406,5 +406,5 @@
 pad = (depth > 8) ? 32 : 8;
 ximg = XCreateImage (mdsp,DefaultVisual(mdsp,scr),
-                     depth,ZPixmap,0,NULL, sx, sy, pad,0);
+                     depth,ZPixmap,0,NULL, sx,sy, pad,0);
 if (ximg == NULL)  return;
 ximg->data = new char [sy*ximg->bytes_per_line];
@@ -412,7 +412,20 @@
   { XFree(ximg); return; }
 
-for(j=0; j<sy; j++)
-  for(i=0; i<sx; i++)
-    { XPutPixel(ximg, i, j, cmap->Color(*pix) );  pix++; }
+if (pixc.BytePointer()) {
+  unsigned char * pix = pixc.BytePointer();
+  for(j=0; j<sy; j++)
+    for(i=0; i<sx; i++)
+      { XPutPixel(ximg, i, j, cmap->Color(*pix) );  pix++; }
+}
+else if (pixc.ShortPointer()) {
+  unsigned short * pix = pixc.ShortPointer();
+  for(j=0; j<sy; j++)
+    for(i=0; i<sx; i++)
+      { XPutPixel(ximg, i, j, cmap->Color(*pix) );  pix++; }
+}
+else {
+  for(j=0; j<sy; j++)
+    for(i=0; i<sx; i++)  XPutPixel(ximg, i, j, 0 );  
+}
 
 XPutImage(mdsp, xw, DefGC(), ximg, 0, 0, (int)x, (int)y, sx, sy);
Index: /trunk/SophyaPI/PI/pigraphx.h
===================================================================
--- /trunk/SophyaPI/PI/pigraphx.h	(revision 4082)
+++ /trunk/SophyaPI/PI/pigraphx.h	(revision 4083)
@@ -38,6 +38,5 @@
   virtual void       DrawMarker(PIGrCoord x0, PIGrCoord y0);
   virtual void       DrawMarkers(PIGrCoord *x, PIGrCoord *y, int n);
-  virtual void       DrawPixmap(PIGrCoord x, PIGrCoord y, unsigned char *pix, 
-                                int sx, int sy, PIColorMap* cmap);
+  virtual void       DrawPixmap(PIGrCoord x, PIGrCoord y,  PIPixColIdx & pix,  PIColorMap* cmap);
 
 // Modifications attributs graphiques
Index: /trunk/SophyaPI/PI/piimage.cc
===================================================================
--- /trunk/SophyaPI/PI/piimage.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/piimage.cc	(revision 4083)
@@ -111,4 +111,6 @@
 gvw = NULL;   // widget vue globale
 cmvw = NULL;  // widget ColorMapView
+fgshowcmap = 0;  // 0: Pas de vue ColMap, 1: top, 2:right,  3:bottom, 4:left
+ cmdid = -1;
 // Fenetre transient et Label pour affichage de l'info (texte PixVal)
 int tx, ty;
@@ -128,7 +130,4 @@
 cutscw = NULL; 
 
-gpixm = zpixm = pixm = NULL;
-xsgpxm = xszpxm = xspxm = 0;
-ysgpxm = yszpxm = yspxm = 0;
 lut = NULL; 
 offx = offy = 0;
@@ -145,5 +144,5 @@
 
 mdrw = new PIElDrawer(false);
- mdrw->SetAxesFlags(kAxesNone);
+mdrw->SetAxesFlags(kAxesNone);
 gvdrw = new PIElDrawer();
 AddDrawer(mdrw, true, false, false, false);
@@ -174,15 +173,12 @@
 PIImage::~PIImage()
 {
-if (pixm) delete pixm;
-if (zpixm) delete zpixm;
 if (zow) 
   {
-  zow->SetPixmap(NULL,0,0);
+  zow->SetPixmap(NULL);
   zow->EraseWindow();
   }
-if (gpixm) delete gpixm;
 if (gvw) 
   {
-  gvw->SetPixmap(NULL,0,0);
+  gvw->SetPixmap(NULL);
   gvw->EraseWindow();
   gvw->SetMsg(0); gvw->SetMsgParent(NULL); 
@@ -256,7 +252,5 @@
 xszpav = yszpav = 1;
 img = pim;
-if (gpixm) delete gpixm;
-gpixm = NULL;
-xsgpxm = ysgpxm = 0;
+gpixm.DeAlloc();
 zmgv = 1;
 
@@ -607,7 +601,13 @@
     // Position du centre d'image
     if (opts.substr(0,12) == "imagecenter=") {
-      int xc = XPave();  
-      int yc = YPave();
+      /* Si on ecrit "imagecenter=34.5,55.5" ca ne marche pas CMV 29/01/2011
+      int xc = XPave(), yc = YPave();
       sscanf(opts.substr(12).c_str(),"%d,%d",&xc, &yc);
+      SetPave(xc, yc, false, true);
+      */
+      int xc = XPave(), yc = YPave();
+      double ddxc = xc, ddyc = yc;
+      sscanf(opts.substr(12).c_str(),"%lf,%lf",&ddxc, &ddyc);
+      xc = int(ddxc+0.00001); yc = int(ddyc+0.00001); 
       SetPave(xc, yc, false, true);
       continue;
@@ -633,12 +633,18 @@
       double min = Lut()->Min();
       double max = Lut()->Max();
+      int typlut=kLutType_Lin;      ;
+      if (opts.substr(4,3) == "lin")  typlut=kLutType_Lin;
+      else if (opts.substr(4,3) == "log")  typlut=kLutType_Log;
+      else if (opts.substr(4,3) == "exp")  typlut=kLutType_Exp;
+      else if (opts.substr(4,4) == "sqrt")  typlut=kLutType_Sqrt;
+      else if (opts.substr(4,6) == "square")  typlut=kLutType_Square;
+      else if (opts.substr(4,3) == "rgb")  { 
+        typlut=kLutType_RGB;
+        min = 0;  max = 255;
+      } 
       size_t q = opts.find(',');
       if (q < opts.length()-1)
 	sscanf(opts.substr(q+1).c_str(),"%lg,%lg",&min, &max);
-      int typlut=kLutType_Lin;      ;
-      if (opts.substr(4,3) == "lin")  typlut=kLutType_Lin;
-      else if (opts.substr(4,3) == "log")  typlut=kLutType_Log;
-      else if (opts.substr(4,4) == "sqrt")  typlut=kLutType_Sqrt;
-      else if (opts.substr(4,6) == "square")  typlut=kLutType_Square;
+
       SetLut(AutoLut_No, min, max, typlut, 0, false);
       continue;
@@ -668,9 +674,24 @@
       continue;
     }
+    if (opts == "showcmap")  UpdateCMapDrawer(1);
+    else if (opts == "noshowcmap")  UpdateCMapDrawer(0);
+    else if (opts.substr(0,9) == "showcmap=") {
+      if (opts.substr(9,2) == "no")   UpdateCMapDrawer(0); 
+      else if (opts.substr(9,3) == "top")     UpdateCMapDrawer(1); 
+      else if (opts.substr(9,5) == "right")   UpdateCMapDrawer(2); 
+      else if (opts.substr(9,6) == "bottom")  UpdateCMapDrawer(3); 
+      else if (opts.substr(9,4) == "left")    UpdateCMapDrawer(4); 
+      else if (opts.substr(9,5) == "horiz")   UpdateCMapDrawer(1); 
+      else if (opts.substr(9,4) == "vert")    UpdateCMapDrawer(2); 
+      else UpdateCMapDrawer(0); 
+    }
+
     ndec--;
     udopt.push_back(opts);
   }
   // Set color map if requested
-  if(fgcmapid || revcmapid) SetColMapId(cmapid,revcmapid,false);
+  if(fgcmapid || revcmapid) 
+    SetColMapId(cmapid,revcmapid,false);  
+
   // Configure axes if requested 
   if (confaxes) ChangeAxesConfiguration(invx, invy, exchxy, false);
@@ -691,4 +712,5 @@
       SetLut(t_al, min_al, max_al, Lut()->Type(), ns_al, false);
   }
+
   return(ndec+ndec2);
 }
@@ -724,13 +746,27 @@
 {
 if (!cmp)  return;
+int ncolold = 0;
+if (cmap) ncolold = cmap->NCol();
+bool fgapp = false;
+if (refr && cmp->NCol() != ncolold) {
+  fgapp = true;  refr = false;
+}
 int cmapid = cmp->Type();
 if ( (cmapid == CMAP_GREY32) || (cmapid == CMAP_GREYINV32) || 
      (cmapid == CMAP_GREY128) || (cmapid == CMAP_GREYINV128))  mdrw->GetGraphicAtt().SetColAtt(PI_Red);
 else mdrw->GetGraphicAtt().SetColAtt(PI_Turquoise);
+if (lut) lut->SetNCol(cmp->NCol());
 PIPixmap::SetColMap(cmp, refr);
 if (refr) { xcurs =  ycurs = -1; }
 if (zow)  zow->SetColMap(cmp, refr);
-if (gvw)  gvw->SetColMap(cmp, refr);
+if (gvw)  { 
+    if (cmap->NCol() != ncolold) { 
+    ComputeGloVPixmap();
+    SetGloVPixmap();
+  }
+  else  gvw->SetColMap(cmp, refr);
+}
 if (cmvw) cmvw->SetColMap(cmap, Lut()->Min(), Lut()->Max(), refr);
+if (fgapp)  Apply();
 return;
 }
@@ -739,11 +775,27 @@
 void PIImage::SetColMapId(CMapId cmapid, bool revidx, bool refr)
 {
+int ncolold = 0;
+if (cmap) ncolold = cmap->NCol();
 if ( (cmapid == CMAP_GREY32) || (cmapid == CMAP_GREYINV32) || 
      (cmapid == CMAP_GREY128) || (cmapid == CMAP_GREYINV128))  mdrw->GetGraphicAtt().SetColAtt(PI_Red);
 else mdrw->GetGraphicAtt().SetColAtt(PI_Turquoise);
-PIPixmap::SetColMapId(cmapid, revidx, refr);
+PIPixmap::SetColMapId(cmapid, revidx, false);
+if (refr) { xcurs =  ycurs = -1; }
+bool fgapp = false;
+if (refr && cmap->NCol() != ncolold) {
+  fgapp = true;  refr = false;
+}
+if (lut) lut->SetNCol(GetColMap()->NCol());
+if (refr) Refresh();
 if (zow)  zow->SetColMapId(cmapid, revidx, refr);
-if (gvw)  gvw->SetColMapId(cmapid, revidx, refr);
+if (gvw)  { 
+    if (cmap->NCol() != ncolold) { 
+    ComputeGloVPixmap();
+    SetGloVPixmap();
+  }
+  else  gvw->SetColMapId(cmapid, revidx, refr);
+}
 if (cmvw) cmvw->SetColMapId(cmapid, revidx, Lut()->Min(), Lut()->Max(), refr);
+if (fgapp)  Apply();
 return;
 }
@@ -754,4 +806,8 @@
 {
 if (img == NULL)  return;
+if (fgshowcmap>0)  {
+  cmpd.SetColMap(GetColMap());
+  cmpd.SetBornes(*Lut());
+}
 if (mw)  {  
   ComputePixmap();
@@ -1111,14 +1167,14 @@
 ywsz = YSize();
 
-pixm = img->ComputePixmap(lut, offx, offy, zoom, xwsz, ywsz, pixm, &xspxm, &yspxm);
+img->ComputePixmap(lut, offx, offy, zoom, xwsz, ywsz, pixm);
 int xw1, yw1, xw2, yw2;
-xw1 = (xwsz-xspxm)/2;
+xw1 = (xwsz-pixm.XSize())/2;
 if (xw1 < 0) xw1 = 0;
-yw1 = (ywsz-yspxm)/2;
+yw1 = (ywsz-pixm.YSize())/2;
 if (yw1 < 0) yw1 = 0;
-xw2 = xspxm+xw1;
-yw2 = yspxm+yw1;
+xw2 = pixm.XSize()+xw1;
+yw2 = pixm.YSize()+yw1;
 SetDefaultDrawRectangle(xw1, yw1, xw2, yw2, false);
-// printf("--DBG-- ComputePixmap() %d %d $ %d %d :: %d %d , %d %d \n", xwsz, ywsz, xspxm, yspxm, xw1, yw1, xw2, yw2);
+// printf("--DBG-- ComputePixmap() %d %d $ %d %d :: %d %d , %d %d \n", xwsz, ywsz, pixm.XSize(), pixm.YSize(), xw1, yw1, xw2, yw2);
 int x1,y1, x2,y2;
 ofx = xw1;  ofy = yw1;
@@ -1131,5 +1187,5 @@
 // printf("--DBG2-- ComputePixmap() %g %g  %g %g  \n", fx1, fx2, fy1, fy2);
 xcurs = ycurs = -1;
-SetPixmap(pixm, xspxm, yspxm, true, xw1, yw1); 
+SetPixmap(&pixm, true, xw1, yw1); 
 // Refresh();
 return; 
@@ -1174,7 +1230,7 @@
 if (lofy < 0)  lofy = 0;
 
-zpixm = img->ComputePixmap(lut, lofx, lofy, zm, xwsz, ywsz, zpixm, &xszpxm, &yszpxm);
+img->ComputePixmap(lut, lofx, lofy, zm, xwsz, ywsz, zpixm);
 zow->SetColMap(cmap, false);
-zow->SetPixmap(zpixm, xszpxm, yszpxm); 
+zow->SetPixmap(&zpixm); 
 zow->SetUserData((void *)this, 0);
 // zow->Refresh();
@@ -1203,6 +1259,6 @@
 zmgv = zmx;
 if (zmx > 1)  zmx = -zmx;
-gpixm = img->ComputePixmap(lut, 0, 0, zmx, xwsz, ywsz, gpixm, &xsgpxm, &ysgpxm);
-// printf("DEBUG-ComputeGloVPixmap()  %d-%d , (%d,%d) , %d-%d \n", xwsz, ywsz, zmx, zmy, xsgpxm, ysgpxm);
+img->ComputePixmap(lut, 0, 0, zmx, xwsz, ywsz, gpixm);
+// printf("DEBUG-ComputeGloVPixmap()  %d-%d , (%d,%d) , %d-%d \n", xwsz, ywsz, zmx, zmy, gpixm.XSize(), gpixm.YSize());
 return;
 }
@@ -1215,10 +1271,10 @@
 
 int xw1, yw1, xw2, yw2;
-xw1 = (gvw->XSize()-xsgpxm)/2;
+xw1 = (gvw->XSize()-gpixm.XSize())/2;
 if (xw1 < 0) xw1 = 0;
-yw1 = (gvw->YSize()-ysgpxm)/2;
+yw1 = (gvw->YSize()-gpixm.YSize())/2;
 if (yw1 < 0) yw1 = 0;
-xw2 = xsgpxm+xw1;
-yw2 = ysgpxm+yw1;
+xw2 = gpixm.XSize()+xw1;
+yw2 = gpixm.YSize()+yw1;
 
 if (zoom > 0) zm = zmgv*zoom;
@@ -1242,5 +1298,5 @@
 gvw->AddDrawer(gvdrw, xw1, yw1, xw2, yw2, false); 
 gvw->SetColMap(cmap, false);
-gvw->SetPixmap(gpixm, xsgpxm, ysgpxm, true, xw1, yw1); 
+gvw->SetPixmap(&gpixm, true, xw1, yw1); 
 gvw->SetUserData((void *)this, 0);
 gvw->SetMsg(Msg()+626);
@@ -1348,4 +1404,34 @@
 //printf("UpdateCuts()-DBG X: %d  -> %g  , Y: %d -> %g \n", cutarrx->Size(), cutarrx->Value(0),
 //       cutarry->Size(), cutarry->Value(0));
+}
+
+/* --Methode-- */
+void PIImage::UpdateCMapDrawer(int fgshow)
+{
+  if ((fgshow<0)||(fgshow>4))  fgshow=0;
+  if (fgshow==fgshowcmap) return;
+  fgshowcmap=fgshow;
+  switch (fgshowcmap ) {
+  case 0 :
+    RemoveDrawer(cmdid); 
+    break;
+  case 1 :
+    cmpd.SetHorizontal();
+    cmdid=AddDrawer(&cmpd, 0.10, 0.02, 0.90, 0.10, true, false);
+    break;
+  case 2 :
+    cmpd.SetVertical();
+    cmdid=AddDrawer(&cmpd, 0.90, 0.1, 0.98, 0.9, true, false);
+    break;
+  case 3 :
+    cmpd.SetHorizontal();
+    cmdid=AddDrawer(&cmpd, 0.10, 0.90, 0.90, 0.98, true, false);
+    break;
+  case 4 :
+    cmpd.SetVertical();
+    cmdid=AddDrawer(&cmpd, 0.02, 0.1, 0.10, 0.9, true, false);
+    break;   
+  } 
+  if (fgshowcmap>0) cmpd.GetGraphicAtt().SetColAtt(PI_Turquoise);
 }
 
Index: /trunk/SophyaPI/PI/piimage.h
===================================================================
--- /trunk/SophyaPI/PI/piimage.h	(revision 4082)
+++ /trunk/SophyaPI/PI/piimage.h	(revision 4083)
@@ -135,4 +135,5 @@
   void SetGloVPixmap();
   void UpdateCuts();
+  void UpdateCMapDrawer(int fgshow);
 
   void DrawCursor(PIGraphic* g);
@@ -154,6 +155,5 @@
   bool winovis;   // $CHECK$ Reza A enlever si possible 17/6/96
 // Tableau des pixels principal  
-  unsigned char * pixm;
-  int xspxm, yspxm;
+  PIPixColIdx pixm;
   LUT * lut;
   AutoLutType t_al;   // Si AutoLut et le type lors du dernier appel a SetLut()
@@ -164,14 +164,15 @@
   int zoom;
   PIPixmap * zow;
-  unsigned char * zpixm;
-  int xszpxm, yszpxm;
-// Fenetre pour l'image entiere  
+  PIPixColIdx zpixm;
+// Fenetre pour vue globale de l'image   
   int zmgv;
   PIPixmap * gvw;
-  unsigned char * gpixm;
-  int xsgpxm, ysgpxm;
+  PIPixColIdx gpixm;
   PIElDrawer* gvdrw;
 // Fenetre d'affichage du ColMap
   PICMapView* cmvw;
+  int fgshowcmap;  // 0: Pas de vue ColMap, 1: top, 2:right, 3:bottom, 4:left
+  PICMapDrawer cmpd;
+  int cmdid;
 // Fenetre/champ de texte
   PILabel * trtlb;
Index: /trunk/SophyaPI/PI/piimgtools.cc
===================================================================
--- /trunk/SophyaPI/PI/piimgtools.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/piimgtools.cc	(revision 4083)
@@ -99,7 +99,9 @@
 mOpt[0] = new PIOptMenu(this, "imglut-opt-1", 1.5*bsx, bsy, cpx, cpy);
 mOpt[0]->AppendItem("Linear", 1100);
-mOpt[0]->AppendItem("Log.", 1101);
-mOpt[0]->AppendItem("Sqrt", 1102);
-mOpt[0]->AppendItem("Square", 1103);
+mOpt[0]->AppendItem("Log", 1101);
+mOpt[0]->AppendItem("Exp", 1102);
+mOpt[0]->AppendItem("Sqrt", 1103);
+mOpt[0]->AppendItem("Square", 1104);
+mOpt[0]->AppendItem("RGB", 1105);
 mOpt[0]->SetValue(1100);
 mOpt[0]->SetBinding(PIBK_elastic,PIBK_elastic, PIBK_elastic,PIBK_elastic);
@@ -174,6 +176,7 @@
 mCasc[1] = new PIMenu(mOptzc[0]->Menu(), "PIUniCol32");
 mCasc[2] = new PIMenu(mOptzc[0]->Menu(), "MIDAS-CMap");
-
-int nsct1,nsct2,nsct3,nsct4;
+mCasc[3] = new PIMenu(mOptzc[0]->Menu(), "RGB-CMap");
+
+int nsct1,nsct2,nsct3,nsct4,nsct5;
 //  D'abord les tables standard de PI  32 couleurs
 nsct1 = 5;   // Les 5 premieres tables
@@ -190,12 +193,16 @@
 mOptzc[0]->AppendPDMenu(mCasc[1]);
 //  Apres les tables importees de MIDAS
-nsct4 = PIColorMap::NumberStandardColorMaps()-2; // Les reste jusqu'a l'avant derniere
+nsct4 = PIColorMap::NumberStandardColorMaps()-6; // Les reste jusqu'a l'avant derniere
 for(kcc=nsct3; kcc<nsct4; kcc++) 
   mCasc[2]->AppendItem(PIColorMap::GetStandardColorMapName(kcc).c_str(), 201+kcc);
 mOptzc[0]->AppendPDMenu(mCasc[2]);
-// Les tables qui restent ( Col16 , ... )
-for(kcc=nsct4; kcc<PIColorMap::NumberStandardColorMaps(); kcc++) 
-mOptzc[0]->AppendItem(PIColorMap::GetStandardColorMapName(kcc).c_str(), 201+kcc);
-// On ajoute un CheckItem pour inverser les index de table de couleur
+nsct5 = PIColorMap::NumberStandardColorMaps()-4; // Les reste jusqu'aux tables RGB
+for(kcc=nsct4; kcc<nsct5; kcc++) 
+  mOptzc[0]->AppendItem(PIColorMap::GetStandardColorMapName(kcc).c_str(), 201+kcc);
+// Les tables de couleur RGB  ( RGB216, RGB512 , ... )
+for(kcc=nsct5; kcc<PIColorMap::NumberStandardColorMaps(); kcc++) 
+  mCasc[3]->AppendItem(PIColorMap::GetStandardColorMapName(kcc).c_str(), 201+kcc);
+mOptzc[0]->AppendPDMenu(mCasc[3]);
+  // On ajoute un CheckItem pour inverser les index de table de couleur
 mOptzc[0]->Menu()->AppendSeparator();
 mOptzc[0]->Menu()->AppendCheckItem("Reverse CMap", 299);
@@ -310,5 +317,5 @@
 for(i=0; i<3; i++)  delete mBut[i];
 delete mButR;
-for(i=0; i<2; i++)  delete mCasc[i];
+for(i=0; i<4; i++)  delete mCasc[i];
 for(i=0; i<5; i++)  delete mButsz[i];
 for(i=0; i<3; i++)  delete mButcax[i];
@@ -371,6 +378,8 @@
   if     ( (mpii->Lut())->Type() == kLutType_Lin )    mOpt[0]->SetValue(1100);
   else if( (mpii->Lut())->Type() == kLutType_Log )    mOpt[0]->SetValue(1101);
-  else if( (mpii->Lut())->Type() == kLutType_Sqrt )   mOpt[0]->SetValue(1102);
-  else if( (mpii->Lut())->Type() == kLutType_Square ) mOpt[0]->SetValue(1103);
+  else if( (mpii->Lut())->Type() == kLutType_Exp )    mOpt[0]->SetValue(1102);
+  else if( (mpii->Lut())->Type() == kLutType_Sqrt )   mOpt[0]->SetValue(1103);
+  else if( (mpii->Lut())->Type() == kLutType_Square ) mOpt[0]->SetValue(1104);
+  else if( (mpii->Lut())->Type() == kLutType_RGB )    mOpt[0]->SetValue(1105);
   else                                                mOpt[0]->SetValue(1100);
 }
@@ -388,5 +397,5 @@
 double min, max, del;
 int lauto, typ;
-int typlut[4] = {kLutType_Lin, kLutType_Log, kLutType_Sqrt, kLutType_Square} ; 
+int typlut[6] = {kLutType_Lin, kLutType_Log,  kLutType_Exp, kLutType_Sqrt, kLutType_Square, kLutType_RGB } ; 
 AutoLutType alts[13] = { AutoLut_No, 
 			 AutoLut_MeanSigma, AutoLut_MeanSigma, AutoLut_MeanSigma,
@@ -446,5 +455,5 @@
     if ((lauto < 0) || (lauto > 12))  lauto = 12;
     typ = mOpt[0]->GetValue() - 1100;
-    if ( (typ < 0) || (typ > 3) )  typ = 0;
+    if ( (typ < 0) || (typ > 5) )  typ = 0;
     (PIImage::CurrentPIImage())->SetLut(alts[lauto], min, max, typlut[typ], nsas[lauto]);
     if (msg == 2500) { 
Index: /trunk/SophyaPI/PI/pilistx.cc
===================================================================
--- /trunk/SophyaPI/PI/pilistx.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/pilistx.cc	(revision 4083)
@@ -116,9 +116,5 @@
 mNItem++;
 
-#if defined(__DECCXX) || defined(__KCC__) || defined(__aCC__)
-XmString xms = XmStringCreate(const_cast<char *>(item), XmSTRING_DEFAULT_CHARSET);
-#else
-XmString xms = XmStringCreate((char *)(item), XmSTRING_DEFAULT_CHARSET);
-#endif
+XmString xms = XmStringCreate(const_cast<char*>(item), const_cast<char*>(XmSTRING_DEFAULT_CHARSET));
 XmListAddItem(mlist, xms, 0);
 XmStringFree(xms);
Index: /trunk/SophyaPI/PI/pimenux.cc
===================================================================
--- /trunk/SophyaPI/PI/pimenux.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/pimenux.cc	(revision 4083)
@@ -386,5 +386,5 @@
   n=0;
   sprintf(acc,"Ctrl/%c", sc[0]);
-  xmstr = XmStringLtoRCreate(acc, XmSTRING_DEFAULT_CHARSET);
+  xmstr = XmStringLtoRCreate(acc, const_cast<char*>(XmSTRING_DEFAULT_CHARSET));
   XtSetArg(warg[n], XmNacceleratorText, xmstr); n++;
   sprintf(acc,"Ctrl<Key>%c", sc[0]);
Index: /trunk/SophyaPI/PI/pipixmapgen.cc
===================================================================
--- /trunk/SophyaPI/PI/pipixmapgen.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/pipixmapgen.cc	(revision 4083)
@@ -8,4 +8,5 @@
 #include "sopnamsp.h"
 #include "pipixmapgen.h"
+
 
 // --------- Methodes de la classe PIPixMap  ----------
@@ -43,7 +44,6 @@
 // long  kind() 
 //	Retourne le type ("=PIPixmap::ClassId")
-// void  SetPixmap(unsigned char *pix, int sx, int sy, bool refr=true, int ox=0, int oy=0)
-//	Associe un tableau d'index "pix" de taille "sx * sy".
-//	(ox,oy)" définissent  l'offset d'affichage.
+// void  SetPixmap(PIPixColIdx *pixidx, int sx, int sy, bool refr=true, int ox=0, int oy=0)
+//	Associe un tableau d'index de couleur "pixidx". (ox,oy)" définissent  l'offset d'affichage.
 //	Si "refr=true", la méthode "Refresh()" est appelée.
 //--
@@ -87,5 +87,5 @@
 {
 pixmap = NULL;
-nx = ny = 0;
+fgownpmap = false;
 ofx = ofy = 0;
 mPpos[0] = mPpos[0] = 0;
@@ -99,21 +99,41 @@
 {
 delete cmap;
+if (fgownpmap && pixmap) delete pixmap;
 }
 
 /* --Methode-- */
-void PIPixmapGen::SetPixmap(unsigned char *pix, int sx, int sy, bool refr, int ox, int oy)
+void PIPixmapGen::SetPixmap(PIPixColIdx *pixidx, bool refr, int ox, int oy)
 {
-pixmap = pix; 
-if (pixmap)
-  {
-  if (sx < 0)  sx = 0;
-  if (sy < 0)  sy = 0;
-  if (ox < 0)  ox = 0;
-  if (oy < 0)  oy = 0;
-  nx = sx; ny = sy;
-  ofx = ox;  ofy = oy;
+if (fgownpmap && pixmap) delete pixmap;
+fgownpmap = false;
+pixmap = pixidx; 
+if (ox < 0)  ox = 0;
+if (oy < 0)  oy = 0;
+ofx = ox;  ofy = oy;
+if (refr) Refresh();   
+}
+
+/* --Methode-- */
+void PIPixmapGen::SetRGBArray(PIPixRGBArray *rgba, CMapId cmapid, bool refr, int ox, int oy)
+{
+if (rgba == NULL) return;
+int quantum = 8;
+if (cmapid == CMAP_RGB216)  quantum = 6;
+else if (cmapid == CMAP_RGB4096) quantum = 16;
+else cmapid = CMAP_RGB512;
+SetColMapId(cmapid, false);
+PIPixColIdx * pixc = new PIPixColIdx;
+pixc->AllocateByte(rgba->XSize(), rgba->YSize());
+for(int j=0; j<rgba->YSize(); j++) 
+  for(int i=0; i<rgba->XSize(); i++) {
+  	PIPixRGB vv = (*rgba)(i,j);
+  	int r = (int)vv.red*quantum/256;
+  	int g = (int)vv.green*quantum/256;
+  	int b = (int)vv.blue*quantum/256;
+    pixc->GetShort(i,j) = (unsigned short)((b*quantum+g)*quantum+r);
   }
-else { ofx = ofy = nx = ny = 0; }
-if (refr) Refresh();   
+SetPixmap(pixc, refr, ox, oy);
+fgownpmap = true;
+return;  
 }
 
Index: /trunk/SophyaPI/PI/pipixmapgen.h
===================================================================
--- /trunk/SophyaPI/PI/pipixmapgen.h	(revision 4082)
+++ /trunk/SophyaPI/PI/pipixmapgen.h	(revision 4083)
@@ -9,5 +9,8 @@
 #include PICMAP_H
 
+#include "pipixutils.h"
+
 #include <list>
+
 
 class PIPixmapGen : public PIBaseWdg
@@ -22,6 +25,7 @@
   virtual long  kind() {return ClassId; }
 
-  virtual void  SetPixmap(unsigned char *pix, int sx, int sy, 
-                          bool refr=true, int ox=0, int oy=0);
+  virtual void  SetPixmap(PIPixColIdx *pixidx, bool refr=true, int ox=0, int oy=0);
+  virtual void  SetRGBArray(PIPixRGBArray *rgba, CMapId cmapid=CMAP_RGB512, 
+                            bool refr=true, int ox=0, int oy=0);
 
   virtual void  SetColMap(PIColorMap* cmp, bool refr=true);
@@ -39,7 +43,7 @@
 
 protected:
-  unsigned char *pixmap;
-  int nx, ny;
-  int ofx, ofy;
+  PIPixColIdx *pixmap;   // Pointeur d'objet PIPixCoIdx, tableau d'index de couleurs, peut etre NULL
+  bool fgownpmap;  // si true -> possede le pixmap et doit le deleter si besoin
+  int ofx, ofy;       // Offset d'affichage 
   PIColorMap* cmap;
 
Index: /trunk/SophyaPI/PI/pipixmapx.cc
===================================================================
--- /trunk/SophyaPI/PI/pipixmapx.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/pipixmapx.cc	(revision 4083)
@@ -7,4 +7,7 @@
 #include "sopnamsp.h"
 #include "pipixmapx.h"
+#include <iostream>
+
+using namespace std;
 
 static  GC    mygc;
@@ -31,20 +34,37 @@
 {
 int i,j;
-unsigned char *pp;
-
-if (pixmap)
-  {
-  for(j=0; j<ny; j++)
-    {
-    pp = pixmap+j*nx;
-    for(i=0; i<nx; i++)
-      { XPutPixel(myximg, i, j, cmap->Color(*pp) );  pp++; }
+int nx = 0;
+int ny = 0;
+if (pixmap!=NULL) {
+  nx = pixmap->XSize();
+  if (nx > XSize())  nx = XSize();
+  ny = pixmap->YSize();
+  if (ny > YSize())  ny = YSize();
+  if (pixmap->BytePointer()!=NULL) {
+    unsigned char *pp = pixmap->BytePointer();
+    for(j=0; j<ny; j++) {
+      pp = pixmap->BytePointer()+j*pixmap->XSize();
+      for(i=0; i<nx; i++)
+        { XPutPixel(myximg, i, j, cmap->Color(*pp) );  pp++; }
+      }
+  }
+  else if (pixmap->ShortPointer()!=NULL) {
+    unsigned short *pp = pixmap->ShortPointer();
+    for(j=0; j<ny; j++) {
+      pp = pixmap->ShortPointer()+j*pixmap->XSize();
+      for(i=0; i<nx; i++)  
+        { XPutPixel(myximg, i, j, cmap->Color(*pp) );  pp++; }
     }
   }
-
+}
+/* ----- On peut laisser le reste - ce n'est pas utilise dans le Draw
+// On remplit le restant 
+for(j=0; j<YSize(); j++)
+  for(i=nx; i<XSize(); i++)
+       XPutPixel(myximg, i, j, 0 );
 for(j=ny; j<YSize(); j++)
-  for(i=nx; i<XSize(); i++)
+  for(i=0; i<XSize(); i++)
      XPutPixel(myximg, i, j, 0 );
-
+------- */
 PIBaseWdgX::Refresh();
 }
@@ -66,5 +86,5 @@
 if (!g) return; 
 if (g->kind() == PI_PSFileGraphics ) {
-    g->DrawPixmap(ofx, ofy, pixmap, nx, ny, cmap);
+    g->DrawPixmap(ofx, ofy, pixmap, cmap);
     //  Il faut faire quelque chose Sinon ??! 
   }
@@ -78,19 +98,26 @@
 
 if (!g) return; 
-if ((myximg == NULL) || (cmap == NULL)) return;
 
 if (g->kind() == PI_PSFileGraphics ) {
-  if (pixmap) g->DrawPixmap(ofx, ofy, pixmap, nx, ny, cmap);
+  g->DrawPixmap(ofx, ofy, (*pixmap), cmap);
   return;
   }
+  
 
 Window xw = XtWindow(XtWdg());
 Display * mdsp = PIXDisplay();
 
+if ((myximg == NULL) || (cmap == NULL) || (pixmap == NULL) ||
+    (pixmap->XSize()<=0) || (pixmap->YSize()<=0) ) {
+  XClearArea(mdsp, xw, x0, y0, dx, dy, False);  return; 
+}
+
 int mx, my, ox, oy;
 
 if (x0 < 0)  x0 = 0;
 if (y0 < 0)  y0 = 0;
-mx = nx+ofx;   my = ny+ofy;
+
+mx = pixmap->XSize()+ofx;   my = pixmap->YSize()+ofy;
+
 if (dx > (XSize()-x0)) dx = XSize()-x0;
 if (dy > (YSize()-y0)) dy = YSize()-y0;
@@ -101,5 +128,4 @@
 
 ox = oy = 0;  
-
 if (ofx > x0)
   { XClearArea(mdsp, xw, x0, y0, ofx-x0, dy, False);   
@@ -115,5 +141,26 @@
 if (my < (y0+dy))
   { XClearArea(mdsp, xw, x0, my, dx, y0+dy-my, False);  dy = my-y0; }
+
+/*
+if (ofx > x0)
+  XClearArea(mdsp, xw, x0, y0, ofx-x0, dy, False);   
+if (ofy > y0)
+  XClearArea(mdsp, xw, x0, y0, dx, ofy-y0, False);  
  
+if (mx < (x0+dx))
+  XClearArea(mdsp, xw, mx, y0, x0+dx-mx, dy, False); 
+if (my < (y0+dy))
+  XClearArea(mdsp, xw, x0, my, dx, y0+dy-my, False);  
+
+if (ofx > x0)
+  { dx -= (ofx-x0);  x0 = ofx;  ox = 0; }
+else  ox = x0-ofx;
+if (ofy > y0)
+  { dy -= (ofy-y0);  y0 = ofy;  oy = 0; }
+else  oy = y0-ofy;
+if (mx < (x0+dx))  dx = mx-x0;
+if (my < (y0+dy))  dy = my-y0;
+*/
+  
 XPutImage(mdsp, xw, mygc, myximg, ox, oy, x0, y0, dx, dy);
 XFlush(mdsp);
Index: /trunk/SophyaPI/PI/piscdrawwdg.cc
===================================================================
--- /trunk/SophyaPI/PI/piscdrawwdg.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/piscdrawwdg.cc	(revision 4083)
@@ -248,4 +248,18 @@
   bool fglogy = isLogScaleY();
 
+  // Flag declenchant SetLimits
+  bool fgsaxel = false;
+  // Limites et sens d'axe
+  double xmin = XMin();
+  double ymin = YMin();
+  double xmax = XMax();
+  double ymax = YMax();
+  int axrl = kAxeDirLtoR;
+  int ayud = kAxeDirDownUp;
+  int xac, yac;
+  GetAxesConfig(xac, yac);
+  if (xac & kAxeDirRtoL) axrl = kAxeDirRtoL;
+  if (yac & kAxeDirUpDown) ayud = kAxeDirUpDown;
+
   for( k=0; k<opt.size(); k++ ) {
     string opts = opt[k];
@@ -259,10 +273,6 @@
     // Limites en x,y
     if (opts.substr(0,9) == "xylimits=") {
-      double xmin = XMin();
-      double ymin = YMin();
-      double xmax = XMax();
-      double ymax = YMax();
       sscanf(opts.substr(9).c_str(),"%lg,%lg,%lg,%lg",&xmin, &xmax,&ymin,&ymax);
-      SetLimits(xmin, xmax, ymin, ymax);
+      fgsaxel = true;
       continue;
     }
@@ -292,6 +302,22 @@
       continue;
     }
-
-// Les attributs d'axes (stdaxes boxaxesgrid ...) sont decodes par PIElDrawer
+    if ((opts == "revax") || (opts == "axerl") ) {
+      fgsaxel = true;  axrl = kAxeDirRtoL;
+      continue;
+    }
+    if ((opts == "revay") || (opts == "axeud") ) {
+      fgsaxel = true;  ayud = kAxeDirUpDown;
+      continue;
+    }
+    if (opts == "axelr") {
+      fgsaxel = true;  axrl = kAxeDirLtoR;
+      continue;
+    }
+    if (opts == "axedu") {
+      fgsaxel = true;  ayud = kAxeDirDownUp;
+      continue;
+    }
+
+// Les autres attributs d'axes (stdaxes boxaxesgrid ...) sont decodes par PIElDrawer
 
     ndec--;
@@ -299,4 +325,5 @@
   }  
 
+  if (fgsaxel)  SetLimits(xmin, xmax, ymin, ymax, axrl, ayud);
   if (fglinlog) SetLogScale(fglogx, fglogy);
 
Index: /trunk/SophyaPI/PI/pistdwdgx.cc
===================================================================
--- /trunk/SophyaPI/PI/pistdwdgx.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/pistdwdgx.cc	(revision 4083)
@@ -51,5 +51,5 @@
 {
 XmString xmstr;
-xmstr = XmStringLtoRCreate((char *)lab.c_str(), XmSTRING_DEFAULT_CHARSET);
+xmstr = XmStringLtoRCreate(const_cast<char*>(lab.c_str()), const_cast<char*>(XmSTRING_DEFAULT_CHARSET));
 int n=0;
 Arg warg[2];
@@ -149,5 +149,5 @@
 {
 XmString xmstr;
-xmstr = XmStringLtoRCreate((char *)lab.c_str(), XmSTRING_DEFAULT_CHARSET);
+xmstr = XmStringLtoRCreate(const_cast<char*>(lab.c_str()), const_cast<char*>(XmSTRING_DEFAULT_CHARSET));
 int n=0;
 Arg warg[2];
Index: /trunk/SophyaPI/PI/pitherm.cc
===================================================================
--- /trunk/SophyaPI/PI/pitherm.cc	(revision 4082)
+++ /trunk/SophyaPI/PI/pitherm.cc	(revision 4083)
@@ -24,5 +24,5 @@
 //--
 //++
-//  PIThermometer(PIContainerGen *par, char *nom, int sx=256, int sy=10, int px=0, int py=0)
+//  PIThermometer(PIContainerGen *par, const char *nom, int sx=256, int sy=10, int px=0, int py=0)
 //	Constructeur - Le choix d'affichage (vertical ou horizontal) dépend
 //	du rapport des tailles "sx", "sy"
@@ -31,5 +31,5 @@
 
 /* --Methode-- */
-PIThermometer::PIThermometer(PIContainerGen *par, char *nom,
+PIThermometer::PIThermometer(PIContainerGen *par, const char *nom,
                        int sx, int sy, int px, int py) 
 : PIBaseWdg(par, nom, sx, sy, px, py)
@@ -139,4 +139,5 @@
 void PIThermometer::Draw(PIGraphicGen* g, int /*x0*/, int /*y0*/, int /*dx*/, int /*dy*/)
 {
+  if (!IsVisible())  return;
   double delta = (max_-min_);
   if (delta < 1.e-39) delta = 1.e-39;
Index: /trunk/SophyaPI/PI/pitherm.h
===================================================================
--- /trunk/SophyaPI/PI/pitherm.h	(revision 4082)
+++ /trunk/SophyaPI/PI/pitherm.h	(revision 4083)
@@ -16,5 +16,5 @@
   enum {ClassId = 5220};
 
-                  PIThermometer(PIContainerGen *par, char *nom,
+                  PIThermometer(PIContainerGen *par, const char *nom,
                                 int sx=256, int sy=10, int px=0, int py=0);
   virtual         ~PIThermometer();
Index: /trunk/SophyaPI/PI/piversion.h
===================================================================
--- /trunk/SophyaPI/PI/piversion.h	(revision 4082)
+++ /trunk/SophyaPI/PI/piversion.h	(revision 4083)
@@ -2,5 +2,5 @@
 #define PIVERSION_H_SEEN
 
-#define PI_VERSIONNUMBER  4.11
+#define PI_VERSIONNUMBER  4.20
 
 #endif
